(function ($) {
  window.wp = window.wp || { };
  window.wp.worthy = {
    setup : false,
    elem : false,
    qualified : false,
    qualified_length : 1800,
    qualified_warn : 1600,
    autoAssignMarker : false,
    contentEditor : null,
    
    counter : function () {
      if (!this.setup) {
        if (!(e = document.getElementById ('wp-word-count')))
          return;
      
        e.appendChild (document.createElement ('br'));
        e.appendChild (document.createTextNode (wpWorthyLang.counter + ': '));
        this.elem = document.createElement ('spam');
        this.elem.setAttribute ('class', 'character-count wp-worthy-counter');
        this.elem.innerHTML = '0';
        e.appendChild (this.elem);
        
        this.setup = true;
      }
      
      if (!this.contentEditor || this.contentEditor.isHidden ())
        text = $('#content').val ();
      else
        text = this.contentEditor.getContent ({ format: 'raw' });
      
      let len = 0;
      
      if (text !== false)
        len = window.wp.worthy.getCharacterCount (text);
      
      this.qualified = (((len >= this.qualified_length) || $('#wp-worthy-lyric').prop ('checked')) && !$('#wp-worthy-ignore').prop ('checked'));
      
      this.elem.innerHTML = len;
      
      if (this.qualified)
        this.elem.setAttribute ('class', 'character-count wp-worthy-counter wp-worthy-length-qualified');
      else if ((len > this.qualified_warn) && (len < this.qualified_length))
        this.elem.setAttribute ('class', 'character-count wp-worthy-counter wp-worthy-length-partial');
      else
        this.elem.setAttribute ('class', 'character-count wp-worthy-counter wp-worthy-length-short');
      
      if ($('#wp-worthy-embed').prop ('disabled') == this.qualified) {
        if (!this.qualified) {
          $('#wp-worthy-embed').prop ('ochecked', $('#wp-worthy-embed').prop ('checked'));
          $('#wp-worthy-embed').prop ('checked', false);
        } else
          $('#wp-worthy-embed').prop ('checked', $('#wp-worthy-embed').prop ('ochecked'));
          
        $('#wp-worthy-embed').prop ('disabled', !this.qualified);
      }
      
      if (this.qualified && this.autoAssignMarker) {
        $('#wp-worthy-embed').prop ('checked', true);
        this.autoAssignMarker = false;
      }
      
      $('#wp-worthy-embed-label').css ('font-weight', this.qualified && !$('#wp-worthy-embed').prop ('checked') ? 'bold' : 'normal');
    },
    
    // {{{ getCharacterCount
    /**
     * Retrive the character-length of a given text-input
     * 
     * @param string text
     * 
     * @access public
     * @return int
     **/
    getCharacterCount : function (text) {
      // Try to parse Shortcodes a bit
      let p = 0,
          e = 0,
          l = 0,
          s = 0,
          t = '',
          n = '';
      
      while ((p = text.indexOf ('[', p)) >= 0) {
        // Try to find end of current shortcode
        if ((e = text.indexOf (']', p)) < p)
          break;
        
        // Get the name of the shortcode
        t = text.substr (p + 1, e - p - 1);
        
        // Skip end-of-shortcode
        if (t.charAt (0) == '/') {
          text = text.substr (0, p) + text.substr (e + 1);
          
          continue;
        }
        
        // Parse the shortcode
        let o = { name : null, attr : { } };
        
        for (s = 0; s < t.length; s++) {
          let c = t.charAt (s);
          
          if (c == ' ') {
            if (o.name == null) {
              o.name = t.substr (0, s);
            } else {
              o.attr [t.substr (l, s - l)] = true;
            }
            
            l = s + 1;
          } else if (c == '=') {
            let k = t.substr (l, s - l);
            
            l = ++s;
            c = t.charAt (l);
            
            if ((c == '"') || (c == "'")) {
              if ((s = t.indexOf (c, l + 1)) >= l + 1)
                o.attr [k] = t.substr (l + 1, s - l - 1);
              else
                break;
              
              l = ++s + 1;
            } else if ((s = t.indexOf (' ', l)) >= l) {
              o.attr [k] = t.substr (l, s - l);
              l = s;
            } else {
              o.attr [k] = t.substr (l);
              s = t.length;
            }
          }
        }
        
        // Make sure we have a shortcode-name
        if (o.name == null)
          o.name = t;
        
        // Push attributes to output
        let ex = '';
        
        if (typeof o.attr.caption != 'undefined')
          ex += o.attr.caption;
        
        if (typeof o.attr.title != 'undefined')
          ex += o.attr.title;
        
        // Strip the shortcode off the text and insert extended attributes
        text = text.substr (0, p) + ex + text.substr (e + 1);
        p += ex.length;
      }
      
      // Get plaintext from html
      let pelem = document.createElement ('div');
      
      pelem.innerHTML = text.replace(/(<([^>]+)>)/ig, '').replace ("\r\n", '');
      
      // Return the length of the result
      if (pelem.childNodes.length == 0)
        return 0;
      
      return (pelem.textContent || pelem.innerText).length;
    },
    // }}}
    
    // {{{ postNotice
    /**
     * Display a notice to the user
     * 
     * @param string message
     * @param string classes
     * 
     * @access public
     * @return void
     **/
    postNotice : function (message, classes) {
      // Make sure we have a notices-area
      if (!(p = document.getElementById ('worthy-notices')))
        return;
      
      // Embed message into a paragraph
      if (message.indexOf ('<p>') < 0)
        message = '<p><strong>Worthy:</strong> ' + message + '</p>';
      
      // Append the message to output
      c = document.createElement ('div');
      c.className = 'notice fade ' + classes;
      c.innerHTML = message;
      
      p.appendChild (c);
    }
    // }}}
  }
  
  $(document).ready (function () {
    window.wp.worthy.autoAssignMarker = ($('#wp-worthy-embed').attr ('data-wp-worthy-auto') == 1);
    
    $('div.worthy-signup form').submit (function () {
      if (!$(this).find ('input#wp-worthy-accept-tac').prop ('checked')) {
        alert (wpWorthyLang.accept_tac);
        
        return false;
      }
    });
    
    $('span.wp-worthy-inline-title').click (function () {
      var box = document.createElement ('div');
      box.setAttribute ('class', 'wp-worthy-inline-title');
      
      var textbox = document.createElement ('input');
      textbox.setAttribute ('type', 'text');
      textbox.setAttribute ('name', this.getAttribute ('id'));
      textbox.setAttribute ('class', 'wp-worthy-inline-title');
      textbox.value = this.textContent.substr (0, this.textContent.lastIndexOf ("\n"));
      box.appendChild (textbox);
      
      var label = document.createElement ('span');
      label.setAttribute ('class', 'wp-worthy-inline-counter');
      box.appendChild (label);
      
      textbox.onchange = function () {
        label.textContent = '(' + this.value.length + ' ' + wpWorthyLang.characters + ')';
      };
      textbox.oninput = textbox.onchange;
      
      this.parentNode.replaceChild (box, this);
      textbox.onchange ();
    });
    
    $('span.wp-worthy-inline-content').click (function () {
      var textbox = document.createElement ('textarea');
      textbox.setAttribute ('name', this.getAttribute ('id'));
      textbox.setAttribute ('class', 'wp-worthy-inline-content');
      textbox.value = this.textContent;
      textbox.style.height = this.clientHeight + 'px';
      this.parentNode.replaceChild (textbox, this);
    });
    
    $('#content').on ('input keyup', function () { window.wp.worthy.counter (); });
    $(document).on ('tinymce-editor-init', function (ev, ed) {
      if (ed.id != 'content')
        return;
      
      window.wp.worthy.contentEditor = ed;
      
      ed.on ('nodechange keyup', function () {
        tinyMCE.triggerSave ();
        window.wp.worthy.counter ();
      });
    });
    
    window.wp.worthy.counter ();
    
    // Insert context-navigation
    let wpw_subnav = $('<div />').addClass ('subnav');
    
    $('#wp-worthy .stuffbox h2[id]').each (function () {
      wpw_subnav.append ($('<a />').attr ('href', '#' + $(this).attr ('id')).text ($(this).text ()));
    });
    
    if (wpw_subnav.children ().length > 1)
      $('#wp-worthy .nav-tab-wrapper').after (wpw_subnav)
    
    // Setup bulk-action-selector
    if ($('th#cb input[type=checkbox]').prop ('checked'))
      $('th.check-column input[type=checkbox]').prop ('checked', true);
    
    // Toggle display of settings related to account-sharing
    $('select#wp-worthy-account-sharing').change (function () {
      $('form.worthy-form .wp-worthy-no-sharing').css ('display', (this.options [this.selectedIndex].value == 0 ? 'block' : 'none'));
    }).change ();
    
    
  });
  
  // Worthy Premium Store
  $(document).ready (function () {
    // {{{ wp-worthy-shop::submit
    /**
     * Place an order on worthy premium shop
     * 
     * @access ui
     * @return void
     **/
    $('#wp-worthy-shop').submit (function () {
      // Make sure anything was selected
      let have_good = false;

      $('#wp-worthy-shop-goods input[type=radio]').each (function () {
        if (this.checked && (this.value != 'none'))
          have_good = true;
      });

      if (!have_good) {
        alert (wpWorthyLang.no_goods);

        return false;
      }
      
      // Make sure terms-and-conditions were accepted
      if (!$(this).find ('input#wp-worthy-accept-tac').prop ('checked')) {
        alert (wpWorthyLang.accept_tac);

        return false;
      }
      
      // Make sure a BIC was entered when using Giropay
      if ($(this).find ('input#wp-worthy-payment-giropay').prop ('checked') && !$(this).find ('input#wp-worthy-payment-giropay-bic').prop ('value').length) {
        alert (wpWorthyLang.empty_giropay_bic);

        return false;
      }
    });
    // }}}
    
    // Setup totals-display on our premium-shop
    $('#wp-worthy-shop-goods input[type=radio]').change (function () {
      var total = 0;
      var total_tax = 0;
      
      $('#wp-worthy-shop-goods input[type=radio]').each (function () {
        if (!this.checked || (this.value == 'none'))
          return;
        
        total += parseFloat ($(this).attr ('data-value'));
        total_tax += parseFloat ($(this).attr ('data-tax'));
      });
      
      $('#wp-worthy-shop-price').html (total.toFixed (2).replace ('.', ','));
      $('#wp-worthy-shop-tax').html (total_tax.toFixed (2).replace ('.', ','));
    });
    
    // Update totals for pre-selected goods
    $('#wp-worthy-shop-goods input[type=radio][checked]').change ();
    
    // Setup Giropay-Widget
    if ($('#wp-worthy-payment-giropay-bic').length > 0)
      $('#wp-worthy-payment-giropay-bic').giropay_widget ({ 'return' : 'bic', 'kind' : 1});
  });
  
  // Worthy for Gutenberg
  $(document).ready (function () {
    // Make sure there is some stuff in place
    if (!wp.i18n)
      return;
    
    let __ = wp.i18n.__;
    
    // {{{ hookGutenbergCounter
    /**
     * Try to hook into Gutenbergs table-of-contents
     * 
     * @remark This is merely an ugly hack because the table-of-contents
     *    component is not able to be extended but we want our counter
     *    to be in the right place.
     **/
    let hookGutenbergCounter = function () {
      let $btn = $('.table-of-contents button');
      
      // Check if the popover-button is in place
      if ($btn.length < 1)
        return;
      if ($btn.prop ('wp-worthy-bound'))
        return;
      
      let hookGutenbergPopover = function () {
        let $table = $('.table-of-contents__counts');
        
        // Check if the table is in place
        if ($table.length < 1)
          return setTimeout (hookGutenbergPopover, 10);
        
        // Append our counter to the table
        $('<div />').addClass ('table-of-contents__count').text (__ ('Characters', 'wp-worthy')).append (
          $('<span />').addClass ('table-of-contents__number').text (wp.worthy.getCharacterCount (wp.data.select ('core/editor').getEditedPostAttribute ('content')))
        ).appendTo ($table);
        
        // Resize all children and the table itself
        $table.children ().css ('width', '20%');
        $table.width ($table.width () * 1.25);
      };
      
      // Bind ourself to the button
      $btn.prop ('wp-worthy-bound', true)
      $btn.click (hookGutenbergPopover);
    };
    
    setInterval (hookGutenbergCounter, 100);
    // }}}
    
    // Make sure we have the wp-API available
    if (!wp || !wp.plugins || !wp.element || !wp.plugins.registerPlugin || !wp.element.createElement)
      return;
    
    var wpWorthyPrepublish = function () {
      // Call parent constructor
      wp.element.Component.apply (this, arguments);
      
      // Initialize state
      this.state = {
        'hasMarkerAssigned' : null,
        'marker' : wp.worthy.autoAssignMarker ? true : null,
        'type' : 'normal'
      };
      
      // Check the marker-state of this post
      let self = this;
      
      wp.apiFetch ({ 'path' : '/wp/v2/posts/' + this.props.postId, 'method' : 'GET' }).then (
        function (data) {
          // Update out marker-state
          self.setState ({
            'hasMarkerAssigned' : ((typeof data ['wp-worthy-marker'] != 'undefined') && (data ['wp-worthy-marker'] !== null) && (typeof data ['wp-worthy-marker'].length != 'undefined') && (data ['wp-worthy-marker'].length > 5)),
            'marker' : data ['wp-worthy-marker'],
            'type' : data ['wp-worthy-type'] || self.state.type
          });
          
          // Forward the result
          return data;
        }
      );
    };
    
    wpWorthyPrepublish.prototype = new wp.element.Component ();
    wpWorthyPrepublish.prototype.render = function () {
      let el = wp.element.createElement,
          self = this;
      
      let typeMap = {
        'lyric' : 'Lyric',
        'normal' : 'Normal text'
      };
      
      return el (
        wp.editPost.PluginPrePublishPanel,
        {
          initialOpen : true,
          className: 'wp-worthy-panel',
          title : [
            __ ('Worthy:'),
            el (
              'span',
              { className : 'editor-post-publish-panel__link text-bold' },
              __ (this.props.qualified ? 'Qualified' : 'Not qualified', 'wp-worthy')
            ),
          ]
        },
        [
          el (
            wp.components.PanelRow,
            { },
            [
              el ('span', { }, __ ('Characters', 'wp-worthy')),
              el ('span', { }, this.props.length)
            ]
          ),
          el (
            wp.components.PanelRow,
            { },
            [
              el ('span', { }, __ ('Marker', 'wp-worthy')),
              el (
                wp.components.Dropdown,
                {
                  'renderToggle' : function (props) {
                    return el (
                      wp.components.Button,
                      { 'onClick' : props.onToggle, 'aria-expanded' : props.isOpen, 'type' : 'button', 'isLink' : true },
                      __ (self.state.marker === false ? 'Ignore' : (self.state.hasMarkerAssigned ? 'Assigned' : (self.state.marker === null ? 'Don\'t assign' : 'Assign')), 'wp-worthy')
                    );
                  },
                  'contentClassName' : 'wp-worthy-gutenberg-dropdown',
                  'renderContent' : function () {
                    return el (
                      'fieldset',
                      { },
                      [
                        el ('div', { }, [
                          el ('input', {
                            'type' : 'radio',
                            'name' : 'wp-worthy-marker',
                            'value' : '1',
                            'id' : 'wp-worthy-gutenberg-marker-assign',
                            'checked' : ((self.state.marker !== null) && (self.state.marker !== false)),
                            'onChange' : function () { self.setState ({ 'marker' : true }); }
                          }),
                          el ('label', { 'htmlFor' : 'wp-worthy-gutenberg-marker-assign' }, __ ('Assign a marker', 'wp-worthy')),
                          el ('p', { }, __ ('This is your destinaion! Write a post that respects all rules by VG-Wort to be reported and rewarded.', 'wp-worthy'))
                        ]),
                        (self.state.hasMarkerAssigned ? null :
                          el ('div', { }, [
                            el ('input', {
                              'type' : 'radio',
                              'name' : 'wp-worthy-marker',
                              'value' : '0',
                              'id' : 'wp-worthy-gutenberg-marker-dont-assign',
                              'checked' : (self.state.marker === null),
                              'onChange' : function () { self.setState ({ 'marker' : null }); }
                             }),
                            el ('label', { 'htmlFor' : 'wp-worthy-gutenberg-marker-dont-assign' }, __ ('Don\'t assign a marker', 'wp-worthy')),
                            el ('p', { }, __ ('If unsure you mag assign a marker later on, e.g. during a text-review.', 'wp-worthy'))
                          ])
                        ),
                        el ('div', { }, [
                          el ('input', {
                            'type' : 'radio',
                            'name' : 'wp-worthy-marker',
                            'value' : '2',
                            'id' : 'wp-worthy-gutenberg-marker-ignore',
                            'checked' : (self.state.marker === false),
                            'onChange' : function () { self.setState ({ 'marker' : false }); }
                          }),
                          el ('label', { 'htmlFor' : 'wp-worthy-gutenberg-marker-ignore' }, __ ('Ignore this post', 'wp-worthy')),
                          el ('p', { }, __ ('If you don\'t want to report this post to VG-Wort, just ignore it.', 'wp-worthy'))
                        ])
                      ]
                    );
                  }
                }
              )
            ]
          ),
          el (
            wp.components.PanelRow,
            { },
            [
              el ('span', { }, __ ('Type of post', 'wp-worthy')),
              el (
                wp.components.Dropdown,
                {
                  'renderToggle' : function (props) {
                    return el (
                      wp.components.Button,
                      { 'onClick' : props.onToggle, 'aria-expanded' : props.isOpen, 'type' : 'button', 'isLink' : true },
                      __ (typeMap [self.state.type], 'wp-worthy')
                    );
                  },
                  'contentClassName' : 'wp-worthy-gutenberg-dropdown',
                  'renderContent' : function () {
                    return el (
                      'fieldset',
                      { },
                      [
                        el ('div', { }, [
                          el ('input', {
                            'type' : 'radio',
                            'name' : 'wp-worthy-type',
                            'value' : 'normal',
                            'id' : 'wp-worthy-gutenberg-texttype-normal',
                            'checked' : (self.state.type != 'lyric'),
                            'onChange' : function () { self.setState ({ 'type' : 'normal' }); }
                          }),
                          el ('label', { 'htmlFor' : 'wp-worthy-gutenberg-texttype-normal' }, __ ('Normal text', 'wp-worthy')),
                          el ('p', { }, __ ('A normal text is just a usual text where all default rules of VG-Wort apply. There is nothing to respect except the typed characters.', 'wp-worthy'))
                        ]),
                        el ('div', { }, [
                          el ('input', {
                            'type' : 'radio',
                            'name' : 'wp-worthy-type',
                            'value' : 'lyric',
                            'id' : 'wp-worthy-gutenberg-texttype-lyric',
                            'checked' : (self.state.type == 'lyric'),
                            'onChange' : function () { self.setState ({ 'type' : 'lyric' }); }
                          }),
                          el ('label', { 'htmlFor' : 'wp-worthy-gutenberg-texttype-lyric' }, __ ('Lyric', 'wp-worthy')),
                          el ('p', { }, __ ('For lyric there are special rules, e.g. thoses posts don\'t depend on length.', 'wp-worthy'))
                        ]),
                      ]
                    );
                  }
                }
              )
            ]
          )
        ]
      );
    };
    
    wpWorthyPrepublish.getDerivedStateFromProps = function (props, state) {
      // Check wheter to push anything back to server
      if (!(props.onPublish || (props.onSave && props.isScheduled)))
        return;
      
      // Push our attributes forward
      wp.apiFetch ({
        'path' : '/wp/v2/posts/' + props.postId,
        'method' : 'POST',
        'data' : {
          'wp-worthy-marker' : state.marker,
          'wp-worthy-type' : state.type
        }
      });
    };
    
    wp.plugins.registerPlugin (
      'wp-worthy-pre-publish',
      {
        render : wp.data.withSelect (function (select, opts) {
          let editor = select ('core/editor'),
              postId = editor.getCurrentPostId (),
              length = wp.worthy.getCharacterCount (editor.getEditedPostAttribute ('content'));
          
          return {
            'onPublish' : editor.isPublishingPost (),
            'onSave' : editor.isSavingPost (),
            'isScheduled' : editor.isCurrentPostScheduled (),
            'postId' : postId,
            'length' : length,
            'qualified' : (length >= 1800)
          };
        })(wpWorthyPrepublish)
      }
    );
  });
}(jQuery));
